# Valkyrie no Densetsu translation tool by A-M
# v 1.0, 3rd sept 2017

import binascii
import sys

# 32 characters size bubbles translations (4 line x 8 char max)
	# stage 1
goddess_01 = ["The Gold", "Seed is", "in evil", "hands"]
goddess_02 = ["Please", "save", "this", "world"]
demon_01 = ["Moron!", "Where's", "the", "Seed?"]
demon_02 = ["Who are", "you? Do", "not dis\xA0", "turb me!"]
mother_01 = ["How can", "I thank", "you?"]
mother_02 = ["Take", "this", "sword of", "light"]
mother_03 = ["and save", "the", "elder in", "the town"]
elder_01 = ["You are", "really", "brave to", "come"]
elder_02 = ["I give", "you this", "split", "magic"]
elder_03 = ["passed", "through", "generat\xA0", "ions"]
	# stage2
elder_04 = ["Well", "done"]
elder_05 = ["Take", "this", "cyclone", "magic"]
earth_spirit_01 = ["Use this", "ladder", "and", "go on!"]
earth_spirit_02 = ["Save the", "elder", "behind", "the rock"]
	# stage 3
woman_01 = ["Well", "done but", "you will", "meet"]
woman_02 = ["a lot of", "dangers", "on the", "road"]
woman_03 = ["Use this", "eternal", "sword"]
woman_04 = ["Sorry", "but it's", "all I", "had"]		# also used by apprentice in stage 4
elder_08 = ["Well", "done", "Take", "this"]
elder_09 = ["size", "growing", "magic"]
quarkman_01 = ["Thanks!", "I'm a", "Quarkman", "Look out"]
quarkman_02 = ["to the", "right", "path's", "floor!"]
quarkman_03 = ["Sorry", "but I", "have", "to go"]
	# stage 4
talos_01 = ["I'm", "Talos", "the Bull", "Gad it?"]
talos_02 = ["Next", "time", "I won't", "be easy!"]
apprentice_01 = ["Thank", "you for", "saving", "me"]
apprentice_02 = ["Here is", "a letter", "for the"]
apprentice_03 = ["elder", "in Lost", "Town"]
elder_10 = ["Well", "done"]
elder_11 = ["Take", "this", "tornado", "magic"]
	# stage 5
elder_12 = ["I won't", "help you", "Go away!"]
elder_13 = ["Oh! This", "is from", "my appr\xA0", "entice!"]
elder_14 = ["Well", "then, I", "can give", "you my"]
elder_15 = ["secret", "chamele\xA0", "on magic"]
	# stage 6
granny_01 = ["It's so", "cold", "here!"]
granny_02 = ["You may", "help me", "to get", "out"]
granny_03 = ["It's not", "much", "but take", "this"]
	# stage 7
elder_16 = ["Well", "done", "you", "found me"]
elder_17 = ["Take", "this", "flight", "magic"]
elder_18 = ["But it", "works", "only", "once!"]
spirit_01 = ["Succeed", "and", "fight", "Kamuz!"]
spirit_02 = ["Hahaha", "bravo!", "Almost", "done!"]
spirit_03 = ["It's the", "last", "trial,", "hold on!"]
spirit_04 = ["Don't", "turn", "your", "back!"]

# 32 characters size bubbles list
bubble_32 = [goddess_01, goddess_02,
			demon_01, demon_02,
			mother_01, mother_02, mother_03,
			elder_01, elder_02, elder_03,
			elder_04, elder_05,
			earth_spirit_01, earth_spirit_02,
			woman_01, woman_02, woman_03, woman_04,
			elder_08, elder_09,
			quarkman_01, quarkman_02, quarkman_03,
			talos_01, talos_02,
			apprentice_01, apprentice_02, apprentice_03,
			elder_10, elder_11,
			elder_12, elder_13, elder_14, elder_15,
			granny_01, granny_02, granny_03,
			elder_16, elder_17, elder_18,
			spirit_01, spirit_02, spirit_03, spirit_04]


# 21 characters size bubbles translations  (3 lines x 7 char max)
	# stage 1
girl_01 = ["Thanks", "Come to", "my home"]		# with Valkyrie
girl_02 = ["Thanks", "Come to", "my home"]		# with Sandra
	# stage 2
thirsty_man_01 = ["The", "source", "above,"]
thirsty_man_02 = ["if I", "could", "go..."]
elder_06 = ["I can't", "help", "you"]			# also used by elder in stage 3 and 7, and granny in stage 6
elder_07 = ["more,", "go now!"]					# also used by elder in stage 3 and 7, and granny in stage 6
	# stage 4
guardian_12 = ["Murmurs", "..."]
man_01 = ["Jump on", "the", "spoons!"]
man_02 = ["Use the", "slide!"]
dancer_01 = ["Elecman", "contro\xA0", "ls us!"]
dancer_02 = ["Mind", "the", "tiles!"]

#21 characters size bubbles list
bubble_21 = [girl_01, girl_02,
			thirsty_man_01, thirsty_man_02,
			elder_06, elder_07,
			guardian_12,
			man_01, man_02,
			dancer_01, dancer_02]


# 42 characters size bubbles translations (3 lines x 14 char max)
zul_01 = ["Welcome"]
zul_02 = ["What do", "you want", "miss Valkyrie?"]
zul_03 = ["What do", "you want", "mister Sandra?"]
zul_04 = ["It seems you", "don't have", "enough money"]
zul_05 = ["Pfff, quickly", "get out!"]
zul_06 = ["A wide beam!"]
zul_07 = ["A homing", "weapon"]
zul_08 = ["I recommend", "this great", "3 way shot!"]
zul_09 = ["A piercing", "weapon!"]
zul_10 = ["A healing", "plant!"]
zul_11 = ["A 4 way shot"]
zul_12 = ["Amazing home", "made bombs!"]
zul_13 = ["A magic", "upgrade book"]
zul_14 = ["A life", "upgrade heart!"]
zul_15 = ["A time extend", "hourglass!"]
zul_16 = ["A mysterious", "dress"]
zul_17 = ["Incredible!", "A magic", "refill!"]

#42 characters size bubbles list
bubble_42 = [zul_01, zul_02, zul_03, zul_04, zul_05,
			zul_06, zul_07, zul_08,
			zul_09, zul_10,
			zul_11, zul_12,
			zul_13,
			zul_14, zul_15, zul_16,
			zul_17]


# 60 characters size bubbles translations (4 lines x 20 char max, 60 char max in total)
	# stage 4
guardian_01 = ["I'm the guardian", "I'll let you pass", "if you answer", "correctly!"]		# before gardian_06
guardian_02 = ["If not, I'll take", "you a heart!"]											# before gardian_06
guardian_01_b = ["I'm the guardian", "I'll let you pass", "if you answer", "correctly!"]	# before gardian_07
guardian_02_b = ["If not, I'll take", "you a heart!"]										# before gardian_07
guardian_03 = ["I'm the master", "of riddles", "I challenge you!"]
guardian_04 = ["I'm like Talos,", "Valkyrie and Sandra", "together..."]
guardian_05 = ["My leg count is?", "A> 8 legs", "B> 9 legs", "C> 10 legs"]
guardian_06 = ["Your destination is?", "A> South Isle", "B> North Source", "C> Sand Land"]
guardian_07 = ["The castle's origin?", "A> Magic Tree", "B> Emerald Egg", "C> Gold Seed"]
guardian_08 = ["Haha you idiot!", "It was A!", "I take you a heart"]
guardian_09 = ["Haha you idiot!", "It was B!", "I take you a heart"]
guardian_10 = ["Haha you idiot!", "It was C!", "I take you a heart"]
guardian_11 = ["Argh I lost!", "As promised I give", "you some magic"]
elecman_01 = ["Who are you?", "You ruined my", "dance party!"]
	# stage 7
mammoth_01 = ["Take up a challenge!", "A> Strength", "B> Mind", "C> I don't want"]
mammoth_02 = ["Strength challenge", "is in the left", "cave"]
mammoth_03 = ["Mind challenge", "is in the right", "cave"]
mammoth_04 = ["You fool!", "Cowards like you", "can't beat Kamuz!", "Come back later!"]
	# stage 8
kamuz_01 = ["You did well,", "But you're gonna", "die here!"]


#60 characters size bubbles list
bubble_60 = [guardian_01, guardian_02, guardian_01_b, guardian_02_b,
			guardian_03, guardian_04,
			guardian_05, guardian_06, guardian_07,
			guardian_08, guardian_09, guardian_10,
			guardian_11,
			elecman_01,
			mammoth_01, mammoth_02, mammoth_03, mammoth_04,
			kamuz_01]


# 33 character size narrative texts (2 lines x 19 char max, 33 char max in total)
	# stage 1
st_01_a = ["They took back the", "Gold Seed"]
st_01_b = ["The freed Wind", "Spirit said:"]
st_01_c = ["Put the Seed in the", "North Source"]
st_01_d = ["It's the only way", "to save us"]
	# stage 2
st_02_a = ["A steep mountain", "blocked their way"]
st_02_b = ["Is there no path", "to the north?"]
st_02_c = ["They thought"]
st_02_d = ["The Earth Spirit", "said: Here is"]
st_02_e = ["a tunnel, but", "be careful!"]
	# stage 3
st_03_a = ["From the exit they", "saw a castle"]
st_03_b = ["It was build thanks", "to the Seed"]
	# stage 4
st_04_a = ["They found a part", "of a gold armor"]
st_04_b = ["It has been","splitted in three"]
st_04_c = ["They went to the", "cursed Lost Town"]
	# stage 5
st_05_a = ["The freed Light", "Spirit said:"]
st_05_b = ["The Gold Seed has", "strange powers"]
st_05_c = ["Once in the North","Source, it can"]
st_05_d = ["grant any wish", "Even evil ones..."]
st_05_e = ["To avoid it we need", "the 4th Spirit"]
st_05_f = ["They left to save", "the Water Spirit"]
	# stage 6
st_06_a = ["The Water", "Spirit said:"]
st_06_b = ["If the Source", "grants the wish of"]
st_06_c = ["the evil Kamuz", "this world will die"]
st_06_d = ["That's why we put", "a barrier on"]
st_06_e = ["the Source and", "we sealed it"]
st_06_f = ["You're the last", "hope of this world"]
st_06_g = ["Show this in front", "of the barrier!"]
	# stage 7	
st_07_a = ["They entered the", "world's core"]
st_07_b = ["But the earth was", "already rotten!"]
st_07_c = ["The evil Kamuz", "has taken"]
st_07_d = ["control of", "the North Source!"]
	# stage 8
st_08_a = ["The evil Kamuz", "was defeated"]
st_08_b = ["\"The world's", "rebirth!\""]
st_08_c = ["They wished with", "all their heart"]
st_08_d = ["They threw the Seed", "in the Source"]
st_08_e = ["The earth", "came back"]
st_08_f = ["to green"]
st_08_g = ["Thus, their", "journey ended"]
st_08_h = ["Valkyrie went", "back to the sky"]
st_08_i = ["Sandra met again", "his family"]
st_08_j = ["About the Seed", "that grants wishes"]
st_08_k = ["In fact it's in", "everyone's heart"]
st_08_l = ["And the only one", "who can use it"]
st_08_m = ["is you"]
st_08_n = ["The heart is like", "the North Source"]
st_08_o = ["It's waiting for", "you to come"]
st_08_p = ["And then..."]
st_08_q = ["A new story", "begins..."]


# 33 character size narrative texts list
narrative_33 = [st_01_a, st_01_b, st_01_c, st_01_d,
				st_02_a, st_02_b, st_02_c, st_02_d, st_02_e,
				st_03_a, st_03_b,
				st_04_a, st_04_b, st_04_c,
				st_05_a, st_05_b, st_05_c, st_05_d, st_05_e, st_05_f,
				st_06_a, st_06_b, st_06_c, st_06_d, st_06_e, st_06_f, st_06_g,
				st_07_a, st_07_b, st_07_c, st_07_d,
				st_08_a, st_08_b, st_08_c, st_08_d, st_08_e,
				st_08_f, st_08_g, st_08_h, st_08_i, st_08_j, st_08_k,
				st_08_l, st_08_m, st_08_n, st_08_o, st_08_p, st_08_q]


# 38 character size narrative texts (2 lines x 19 char max)
	# stage 7
puzzle_01 = ["I'll test your mind"]
puzzle_02 = ["Solve the puzzles!"]
puzzle_03 = ["Go!"]			# first 3 ones
puzzle_03_b = ["Go!"]		# last one
puzzle_04 = ["You can't?", "Well, try this one"]
puzzle_05 = ["Hmmm not great, the", "next one is hard!"]
puzzle_06 = ["Terrible! Only a", "miracle can save us"]
puzzle_07 = ["Well done!", "Try the next one"]
puzzle_08 = ["Alright, the last", "one is hard!"]
puzzle_09 = ["Fantastic! You", "are a real hero!"]
puzzle_10 = ["Defeat Kamuz!"]

# 38 character size narrative texts list
narrative_38 = [puzzle_01, puzzle_02, puzzle_03, puzzle_03_b,
				puzzle_04, puzzle_05, puzzle_06, 
				puzzle_07, puzzle_08, puzzle_09, puzzle_10]


# hard coded texts
valkyrie_01 = "Bye!"	# must be 4 characters, put space if needed
end_01 = "  E N D"		# must be 7 characters, put space if needed, stick the text to the right since it's not well centered in the game



# texts address table is at 0x0325B8
# [address of the text, address of the address]
address_32  = [["0x00032A54", "0x0325C0"],	# goddess_01
			["0x00032AA6", "0x0325C4"],		# goddess_02
			["0x00032DB2", "0x032634"],		# demon_01
			["0x00032DE8", "0x032638"],		# demon_02
			["0x00032B92", "0x0325F4"],		# mother_01
			["0x00032BBE", "0x0325F8"],		# mother_02
			["0x00032BEA", "0x0325FC"],		# mother_03
			["0x00032E26", "0x032674"],		# elder_01
			["0x00032E64", "0x032678"],		# elder_02
			["0x00032E90", "0x03267C"],		# elder_03
			["0x00032EBA", "0x03260C"],		# elder_04
			["0x00032ED4", "0x032610"],		# elder_05
			["0x00033D98", "0x032760"],		# earth_spirit_01
			["0x00033DD0", "0x032764"],		# earth_spirit_02
			["0x00032C22", "0x0327AC"],		# woman_01
			["0x00032C42", "0x0327B0"],		# woman_02
			["0x00032C72", "0x0327B4"],		# woman_03
			["0x00032CAA", "0x03282C"],		# woman_04
			["0x00032EBA", "0x032620"],		# elder_08
			["0x00032F3E", "0x032624"],		# elder_09
			["0x000331E6", "0x03296C"],		# quarkman_01
			["0x00033220", "0x032970"],		# quarkman_02
			["0x00033262", "0x032974"],		# quarkman_03
			["0x00033E12", "0x032798"],		# talos_01
			["0x00033E50", "0x03279C"],		# talos_02
			["0x00032CE8", "0x0329BC"],		# apprentice_01
			["0x00032D04", "0x0329C0"],		# apprentice_02
			["0x00032D1E", "0x0329C4"],		# apprentice_03
			["0x00032EBA", "0x03273C"],		# elder_10
			["0x00032F68", "0x032740"],		# elder_11
			["0x00032F90", "0x0327C4"],		# elder_12
			["0x00032FC8", "0x0329A4"],		# elder_13
			["0x00033002", "0x0329A8"],		# elder_14
			["0x00033030", "0x0329AC"],		# elder_15
			["0x0003306C", "0x0327D4"],		# granny_01
			["0x0003308E", "0x0327D8"],		# granny_02
			["0x000330C8", "0x0327DC"],		# granny_03
			["0x00033106", "0x0329D4"],		# elder_16
			["0x00033136", "0x0329D8"],		# elder_17
			["0x00033168", "0x0329DC"],		# elder_18
			["0x00033E92", "0x0327EC"],		# spirit_01
			["0x00033F00", "0x03280C"],		# spirit_02
			["0x00033F40", "0x03281C"],		# spirit_03
			["0x00033ED2", "0x0327FC"]		# spirit_04
			]

address_21 = [["0x00032B32", "0x0325D4"],	# girl_01
			["0x00032B62", "0x0325E4"],		# girl_02
			["0x000331A0", "0x032774"],		# thirsty_man_01
			["0x000331C6", "0x032778"],		# thirsty_man_01
			["0x00032EFE", "0x032660"],		# elder_06
			["0x00032F24", "0x032664"],		# elder_07
			["0x0003366E", "0x03272C"],		# guardian_12
			["0x00032D56", "0x032984"],		# man_01
			["0x00032D84", "0x032994"],		# man_02
			["0x00033A92", "0x03283C"],		# dancer_01
			["0x00033ABC", "0x03284C"]		# dancer_02
			]

address_42 = [["0x00033692", "0x03268C"],	# zul_01
			["0x000336A6", "0x03269C"],		# zul_02
			["0x000336CE", "0x0326AC"],		# zul_03
			["0x00033A24", "0x03295C"],		# zul_04
			["0x000339F0", "0x03294C"],		# zul_05
			["0x000338AC", "0x0328EC"],		# zul_06
			["0x00033860", "0x0328CC"],		# zul_07
			["0x00033948", "0x03291C"],		# zul_08
			["0x000338E8", "0x0328FC"],		# zul_09
			["0x000339C8", "0x03293C"],		# zul_10
			["0x000337BE", "0x03289C"],		# zul_11
			["0x0003381E", "0x0328BC"],		# zul_12
			["0x00033756", "0x03287C"],		# zul_13
			["0x00033722", "0x03286C"],		# zul_14
			["0x0003378A", "0x03288C"],		# zul_15
			["0x00033916", "0x03290C"],		# zul_16
			["0x00033A56", "0x0329FC"]		# zul_17
			]

address_60 = [["0x000333A8", "0x032A0C"],	# guardian_01
			["0x0003341E", "0x032A10"],		# guardian_02
			["0x000333A8", "0x032A24"],		# guardian_01_b
			["0x0003341E", "0x032A28"],		# guardian_02_b
			["0x00033296", "0x032648"],		# guardian_03
			["0x000332F8", "0x03264C"],		# guardian_04
			["0x00033346", "0x032650"],		# guardian_05
			["0x0003345A", "0x032A14"],		# guardian_06
			["0x000334D0", "0x032A2C"],		# guardian_07
			["0x000335A2", "0x0326CC"],		# guardian_08
			["0x000335E6", "0x032A3C"],		# guardian_09
			["0x0003362A", "0x032A4C"],		# guardian_10
			["0x00033548", "0x032788"],		# guardian_11
			["0x00033AE2", "0x0326DC"],		# elecman_01
			["0x00033B32", "0x0326EC"],		# mammoth_01
			["0x00033BB4", "0x0326FC"],		# mammoth_02
			["0x00033C02", "0x03270C"],		# mammoth_03
			["0x00033C4C", "0x03271C"],		# mammoth_04
			["0x00033F82", "0x0329EC"]		# kamuz_01
			]

address_33 = [["0x00017C62", "0x017B00"],	# st_01_a
			["0x00017C9E", "0x017B0C"],		# st_01_b
			["0x00017CDA", "0x017B18"],		# st_01_c
			["0x00017D10", "0x017B24"],		# st_01_d
			["0x0001C0F4", "0x01BFA4"],		# st_02_a
			["0x0001C13C", "0x01BFB0"],		# st_02_b
			["0x0001C168", "0x01BFBC"],		# st_02_c
			["0x0001C18C", "0x01BFC8"],		# st_02_d
			["0x0001C1DC", "0x01BFD4"],		# st_02_e
			["0x0001C58A", "0x01C53A"],		# st_03_a
			["0x0001C5CA", "0x01C546"],		# st_03_b
			["0x0001C99E", "0x01C952"],		# st_04_a
			["0x0001C9D6", "0x01C95E"],		# st_04_b
			["0x0001CA26", "0x01C96A"],		# st_04_c
			["0x0001CE9E", "0x01CE46"],		# st_05_a
			["0x0001CEDA", "0x01CE52"],		# st_05_b
			["0x0001CF1C", "0x01CE5E"],		# st_05_c
			["0x0001CF6A", "0x01CE6A"],		# st_05_d
			["0x0001CF96", "0x01CE76"],		# st_05_e
			["0x0001CFDC", "0x01CE82"],		# st_05_f
			["0x0001D4F6", "0x01D486"],		# st_06_a
			["0x0001D51C", "0x01D492"],		# st_06_b
			["0x0001D560", "0x01D49E"],		# st_06_c
			["0x0001D598", "0x01D4AA"],		# st_06_d
			["0x0001D5E6", "0x01D4B6"],		# st_06_e
			["0x0001D626", "0x01D4C2"],		# st_06_f
			["0x0001D660", "0x01D4CE"],		# st_06_g
			["0x0001DB3E", "0x01DAF2"],		# st_07_a
			["0x0001DB86", "0x01DAFE"],		# st_07_b
			["0x0001DBC8", "0x01DB0A"],		# st_07_c
			["0x0001DC02", "0x01DB16"],		# st_07_d
			["0x0002CCE0", "0x02CBDC"],		# st_08_a
			["0x0002CD1E", "0x02CBE4"],		# st_08_b
			["0x0002CD60", "0x02CBEC"],		# st_08_c
			["0x0002CD8A", "0x02CBF4"],		# st_08_d
			["0x0002CE7A", "0x02CBFC"],		# st_08_e
			["0x0002CE98", "0x02CC04"],		# st_08_f
			["0x0002CEBC", "0x02CC0C"],		# st_08_g
			["0x0002CEF2", "0x02CC14"],		# st_08_h
			["0x0002CDC8", "0x02CC1C"],		# st_08_i
			["0x0002CE02", "0x02CC24"],		# st_08_j
			["0x0002CE3A", "0x02CC2C"],		# st_08_k
			["0x0002CF2E", "0x02CC34"],		# st_08_l
			["0x0002CF68", "0x02CC3C"],		# st_08_m
			["0x0002CF88", "0x02CC44"],		# st_08_n
			["0x0002CFBC", "0x02CC4C"],		# st_08_o
			["0x0002CFFA", "0x02CC54"],		# st_08_p
			["0x0002D018", "0x02CC5C"]		# st_08_q
			]

address_38 = [["0x0001EEC6", "0x01F238"],		# puzzle_01
			["0x0001EEF4", "0x01F23C"],		# puzzle_02
			["0x0001F0E4", "0x01EB18"],		# puzzle_03
			["0x0001F0E4", "0x01EC02"],		# puzzle_03_b
			["0x0001EF20", "0x01ED34"],		# puzzle_04
			["0x0001F116", "0x01ED2C"],		# puzzle_05
			["0x0001EFAA", "0x01E86E"],		# puzzle_06
			["0x0001EF62", "0x01EC96"],		# puzzle_07
			["0x0001F098", "0x01EC8E"],		# puzzle_08
			["0x0001F026", "0x01E822"],		# puzzle_09
			["0x0001F072", "0x01E842"]		# puzzle_10
			]


# herd coded texts addresses
address_valkyrie = ["0x025938", "0x025932", "0x02592C", "0x025926"]
address_end = "0x02DEA6"



# free spaces :
# 0x02DFB0 - 0x02FFFF (4128 characters, biggest one, for texts in bubbles)
# 0x036380 - 0x037FFF (3648 characters, for stage ending texts)

# convert address to decimal and split it because of the 2 files
pointer = int("0x02DFB0",16) / 2;
pointer2 = int("0x036380",16) / 2;


# byte manipulation functions
def ByteToHex(byteStr):
	return ''.join(["%02X " % ord(x) for x in byteStr]).strip()

def HexToByte(hexStr):
	bytes = []
	hexStr = ''.join(hexStr.split(" "))
	for i in range(0, len(hexStr), 2):
		bytes.append(chr(int(hexStr[i:i+2], 16)))
	return ''.join(bytes)



# bubbles texts function
def writeBubbles(text_table, address_table, max_line, max_len, max_char):
	for z in range(len(text_table)):

		# put the new address in a table, address table will be modified after thanks to that
		address_table[z][0] = int(mpr0.tell()) * 2

		# count for character
		nb_char = 0;

		# fetch the lines of the bubble
		for i in range(len(text_table[z])):

			# bubble's sentences informations
			txt = text_table[z][i]
			ln = len(txt)
			nb_char = nb_char + ln

			# line count check
			if i > max_line - 1:
				print "Too many lines at \"",text_table[z][i], "\", should be",max_line, "maximum"
				sys.exit()

			# line length check
			elif ln > max_len:
				print "String too long at \"",text_table[z][i], "\", should be",max_len, "maximum"
				sys.exit()

			# character count check
			elif nb_char > max_char:
				print "Too many characters at \"",text_table[z][i], "\", should be",max_char, "maximum"
				sys.exit()

			# if ok, print into both mpr0 and mpr1 files
			else:
				# print 00 in mpr0 (offset, always keep it to 0, except for katakana)
				for g in range(ln):
					mpr0.write("\x00")

				# print sentence in mpr1
				mpr1.write(text_table[z][i])

				# print line break (00 0D)
				mpr0.write("\x00")
				mpr1.write("\x0D")

		# print FF FF to indicate the end of the bubble
		mpr0.write("\xFF")
		mpr1.write("\xFF")
	print max_char,"characters bubbles done"


# narrative texts function
def writeNarrative(text_table, address_table, max_line, max_len, max_char):
	for z in range(len(text_table)):

		# put the new address in a table, address table will be modified after thanks to that
		address_table[z][0] = int(mpr0.tell()) * 2

		# count for lines
		lines = len(text_table[z])

		# count for character
		nb_char = 0;

		for i in range(lines):
			# text's sentences informations
			txt = text_table[z][i]
			ln = len(txt)
			nb_char = nb_char + ln

			# line count check
			if i > max_line - 1:
				print "Too many lines at \"",text_table[z][i], "\", should be",max_line, "maximum"
				sys.exit()

			# line length check
			elif ln > max_len:
				print "String too long at \"",text_table[z][i], "\", should be",max_len, "maximum"
				sys.exit()

			# character count check
			elif nb_char > max_char:
				print "Too many characters at \"",text_table[z][i], "\", should be",max_char, "maximum"
				sys.exit()

			# if ok, print into both mpr0 and mpr1 files
			else:
				if i == 0:
					# print line infos at the beginning (000nb of lines 0005 001B)
					mpr0.write("\x00\x00\x00")
					if lines == 1:
						mpr1.write("\x01\x05\x1B")
					else:
						mpr1.write("\x02\x05\x1B")

				# print 00 in mpr0 (offset, always keep it to 0, except for katakana)
				for g in range(ln):
					mpr0.write("\x00")

				# print sentence in mpr1
				mpr1.write(text_table[z][i])

				if i == 0 and lines > 1:
					# print line break (FF FF 00 05 00 1D)
					mpr0.write("\xFF\x00\x00")
					mpr1.write("\xFF\x05\x1D")

		# print FF FF to indicate the end of the text
		mpr0.write("\xFF")
		mpr1.write("\xFF")
	print max_char,"narrative texts done"


# address function
def updateAddress(address_table, max_char):
	# write the new addresses in the address table
		for y in range(len(address_table)):

			# position cursor in files
			pos = int(address_table[y][1],16) / 2
			mpr0.seek(pos)
			mpr1.seek(pos)

			# convert address in hexa
			addr = "{:02x}".format(address_table[y][0])
			addr = "000" + str(addr)
			addr = (ByteToHex(HexToByte(addr))).split(" ")
			
			# write the new address
			mpr0.write(binascii.unhexlify(str(addr[0])))
			mpr1.write(binascii.unhexlify(str(addr[1])))
			mpr0.write(binascii.unhexlify(str(addr[2])))
			mpr1.write(binascii.unhexlify(str(addr[3])))
		print max_char,"characters texts addresses updated"


# hard coded texts function
def hardCodedText():
	# Valkyrie's bubble
	if len(valkyrie_01) != 4:
		print "String \"",valkyrie_01, "\", should be",4, "characters"
		sys.exit()

	text = list(valkyrie_01);
	for x in range(len(address_valkyrie)):
		mpr1.seek(int(address_valkyrie[x],16) / 2)
		mpr1.write(text[x]);

	# End text
	if len(end_01) != 7:
		print "String \"",end_01, "\", should be",7, "characters"
		sys.exit()

	mpr1.seek(int(address_end,16) / 2)
	mpr1.write(end_01);

	print "hard coded texts updated"



# main program
with open("wd1mpr0.bin", "r+b") as mpr0:
	with open("wd1mpr1.bin", "r+b") as mpr1:

		# position cursor in files for bubbles
		mpr0.seek(pointer)
		mpr1.seek(pointer)

		# write 32 characters size bubbles
		writeBubbles(bubble_32, address_32, 4, 8, 32)

		# write 21 characters size bubbles
		writeBubbles(bubble_21, address_21, 3, 7, 21)

		# write 42 characters size bubbles
		writeBubbles(bubble_42, address_42, 3, 14, 42)

		# write 60 characters size bubbles
		writeBubbles(bubble_60, address_60, 4, 20, 60)

		# position cursor in files for narrative texts
		mpr0.seek(pointer2)
		mpr1.seek(pointer2)

		# write 33 characters size narrative texts
		writeNarrative(narrative_33, address_33, 2, 19, 33)

		# write 38 characters size narrative texts
		writeNarrative(narrative_38, address_38, 2, 19, 38)

		# update 32 characters size bubbles address
		updateAddress(address_32, 32)

		# update 21 characters size bubbles address
		updateAddress(address_21, 21)

		# update 42 characters size bubbles address
		updateAddress(address_42, 42)

		# update 60 characters size bubbles address
		updateAddress(address_60, 60)

		# update 33 characters size narrative text address
		updateAddress(address_33, 33)

		# update 38 characters size narrative text address
		updateAddress(address_38, 38)

		# modify hard coded texts
		hardCodedText()



# everything went well
print "SUCCESS"